#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "config.h"
#include "sockio.h"

int read_string(int sockfd, char *pszString, int iMaxLength)
{
	char c;
	int i, j;
	
// TODO - It'll be more faster to read bigger junks of data.
//	       We need also some additional error handling.	
	for (i = 0; i < iMaxLength - 1; i++) {
		if (1 == (j = read(sockfd, &c, 1))) {
			if ('\0' == c)
				break;
			*pszString++ = c;
		} else if (0 == j)					// EOF
			break;
		else
			return -1;							// Error
	}

	*pszString = '\0';
	return i;
}

int write_string(int sockfd, char *pszString)
{
	int iResult = write(sockfd, pszString, strlen(pszString) + 1);
	
	if ((int)(strlen(pszString) + 1) != iResult)
		return -1;								// Error
	
	return iResult;
}

int read_integer(int sockfd, int *pi)
{
	return (read(sockfd, pi, sizeof(int)) == sizeof(int));	
}

int write_integer(int sockfd, int i)
{
	return (write(sockfd, &i, sizeof(i)) == sizeof(i));	
}

int read_byte(int sockfd, unsigned char *pc)
{
	return (read(sockfd, pc, sizeof(unsigned char)) == sizeof(unsigned char));
}

int write_byte(int sockfd, unsigned char c)
{
	return (write(sockfd, &c, sizeof(unsigned char)) == sizeof(unsigned char));
}
